Unit AFE1C_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTAF12_p;

procedure AFE1C(var A :Array of Real; var BR :Array of Real;
                var BI :Array of Real; var D :Array of Real;
                var FR :Array of Real; var FI :Array of Real;
                N :Integer; var IERR :Integer);

implementation

procedure AFE1C(var A :Array of Real; var BR :Array of Real;
                var BI :Array of Real; var D :Array of Real;
                var FR :Array of Real; var FI :Array of Real;
                N :Integer; var IERR :Integer);
var
I :Integer;
G,G1,G2,BRI,BII,B,UR,UI,VR,VI :Real;
label
_1,_2,_3,_4,_5;
begin
IERR := 0;
G := D[0];
if ( G <= 0.0 ) 
 then goto _4;
A[0] := A[0]/G;
G := Sqrt(G);
UR := 1.0;
UI := 0.0;
FR[0] := 1.0/G;
FI[0] := 0.0;
if ( N = 1 ) 
 then goto _5;
for I:=2 to N do
 begin
  G1 := G;
  G := D[I-1];
  if ( G <= 0.0 ) 
   then goto _4;
  A[I-1] := A[I-1]/G;
  G := Sqrt(G);
  G2 := G1*G;
  BRI := BR[I-1];
  BII := BI[I-1];
  B := Cabs(Cmplx(BRI,BII));
  if ( B = 0.0 ) 
   then goto _1;
  BRI := BRI/B;
  BII := BII/B;
  VR := UR*BRI+UI*BII;
  VI := UI*BRI-UR*BII;
  goto _2;
_1:
  VR := 1.0;
  VI := 0.0;
_2:
  FR[I-1] := VR/G;
  FI[I-1] := VI/G;
  BR[I-1] := B/G2;
  UR := VR;
  UI := VI;
_3:
 end;
goto _5;
_4:
IERR := 65;
UTAF12(65,2);
_5:
end;

end.
